<?php
// archivo: mantnews.php
// Este archivo: /admin/mantnews.php
// pgina de mantenimiento de las listas de correo
// y para el envo de mensajes masivos a los suscriptores

// explicacin en captulo 29

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////
require_once("plantilla.php");

// Esta pgina permite realizar el mantenimiento de mensajes
// por lo que slo la utiliza el administrador (autenticado)
// Desde esta pgina se pueden realizar altas, bajas y modificaciones
// de la tabla de mensajes de noticias (Newsletter)

if ($_SESSION['Autenticado']!=1 ) {       
      redirect("admin.php");
}

// Si se quiere probar esta pgina de modo independiente
// ajustar estos valores y activar las siguientes
// instrucciones 
//$_SESSION =Array ( "Autenticado" => "1" , "LOGIN" => "admincom", "PalabraPaso" => "123456" );
//$_POST =Array ( "vProveedorID" => "2", "vNombre" => "D\'Andrea", "vApellidos" => "Rey Paz",  "vEmpresa" => "Distribuidora Norte", "vEMail" => "q@w.com", "Op" => "Modificar" ); 



// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUADM);

// tabla de navegacin del administrador del sitio
tabnavegaA($aMENU04,LIT22001,LIT00011);

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios de administrador
// dado que esta pgina es de uso exclusivo del
// administrador 
////////////////////////////////////////////////////
conectar(USERADMIN,PSWUSERADMIN);

// se crea un objeto Newsletter (vaco)
$oMensaje = New Newsletter();
$sFiltro="";
// Rutina de insercin de un nuevo mensaje de noticias
// En modificaciones, eliminaciones e inserciones se
// utilizan los campos POST para completar el contenido del
// objeto Newletter para hacer la operacin SQL correspondiente
if (($_POST["Op"]=="Aadir")) {
      $oMensaje->Noticia = $_POST["INoticia"];
      $oMensaje->aadirNewsletter();    
}

// Rutina de modificacin de un mensaje de noticias
elseif ($_POST["Op"]=="Modificar") {
      $oMensaje->NewsID = $_POST["vNewsID"];
      $oMensaje->Noticia = $_POST["vNoticia"];
      $oMensaje->modificarNewsletter();  
}

// Rutina de eliminacin de un mensaje de noticias
elseif ($_POST["Op"]=="Eliminar") {
      $oMensaje->NewsID = $_POST["vNewsID"];
      $oMensaje->eliminarNewsletter(); 
}

// Rutina de envo del mensaje de noticias
// a la lista de correos
elseif ($_POST["Op"]=="Enviar") {
      $oMensaje->leerNewsLetter($_POST["vNewsID"]);
      $oMensaje->enviarNewsletter(); 
}

// Rutina de filtrado de mensajes
// se crea la clusula WHERE para definir el filtro
elseif ($_POST["Op"]=="BuscarTabla") {
  $sFiltro=" WHERE Noticia Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="     Estado Like '%".trim($_POST['BTexto'])."%'";
}

// Se crea un objeto Newsletters
// que tiene la lista de
// los mensajes utilizando el filtro
// definido previamente
$oNews = New Newsletters;
$aNews = $oNews->leerNewsletters($sFiltro); 

// Crea un objeto TablaHTML
$oTab2 = new  TablaHTML("Comercio");

// Formulario para la insercin de nuevos mensajes
unset($aB);
$aB[0]="<form name='form11' method='POST' action='".SELF."' enctype='multipart/form-data'>";
$sTitFila[]=" ";
$aB[1]="<textarea  cols='60' rows='10'  name='INoticia' value=''></textarea>";
$aB[2]="Nuevo";
$aB[3]="<input type='image' src ='".PATHGIF."insertar.gif'   
  value='Aadir' TITLE='".LIT00009."' onClick='document.form11.Op.value=\"Aadir\";' >\n";
$aB[3].="<input type='hidden' name='Op' value=' '>\n";
$aB[4]="</form>";

$oTab2->aadir_fila($aB);

// Coloca los ttulos de las columnas
// los literales propios de esta pgina utilizan
// el prefijo LIT22
$oTab2->asignar_titulos_columnas(LIT22002,LIT22004,LIT22003);
 

// Formularios para la eliminacin y modificacin de mensajes
// uno por cada lnea de la tabla
// navega por el conjunto de resultados
$op="<option value='0' >Ninguno</option>";

// iteracin por el conjunto de resultados de la lectura de la tabla
$i=0;

while ($i < $oNews->cantNewsletters()) {
  unset($aB);
  $aB[0]="<form name='form11".$i."' method='POST' enctype='multipart/form-data'>";
  $aB[0].="<input type='hidden' name='vNewsID' value='".$aNews[$i]['NewsID']."'>";
  $aB[1]="<textarea  cols='60' rows='10'  name='vNoticia'>". clean($aNews[$i]['Noticia'])."</textarea>";
  $aB[2]= clean($aNews[$i]['Estado']);
  $aB[3]="<input type='image' src ='".PATHGIF."eliminar.gif'   
  value='Eliminar' TITLE='".LIT00007."'   onClick='document.form11".$i.".Op.value=\"Eliminar\";' >\n";
  $aB[4]="<input type='image' src ='".PATHGIF."modificar.gif'   
  value='Modificar' TITLE='".LIT00008."' onClick='document.form11".$i.".Op.value=\"Modificar\";' >\n";
  $aB[5]="<input type='image' src ='".PATHGIF."correo.gif'   
  value='Enviar email' TITLE='".LIT00017."' onClick='document.form11".$i.".Op.value=\"Enviar\";' >\n";
  $aB[5].="<input type='hidden' name='Op' value=' '>\n";
  $aB[6]="</form>";
  
  // se utiliza el identificador del mensaje como ttulo de la fila
  // esta columna no se puede modificar
  $sTitFila[]=$aNews[$i]['NewsID'];
  $i++;
  $oTab2->aadir_fila($aB);
}


// coloca los ttulos de cada fila
$oTab2->asignar_titulos_filas($sTitFila);

echo $oTab2->retornoHTML();
echo "</form>";

// informacin de pie de pgina
cerrarPagina();
?>