<?php
class Cesta { // clase Cesta
    //	archivo \bib\clases\clCesta.php
    // explicacin captulo 19

   /**
    * Propiedades
    */
    private $_aLista=array();
    private $_aItems=array();
    private $_bDirty=False;
   /*
    * Mtodos
    * __construct() // Constructor
    * aadirCesta()
    * modificarCesta()
    * eliminarCesta()  
    * leerItemsCesta() 
    * totalizarCesta() 
    * cantItems()
    * leerCesta() 

    */
function __construct() { // Constructor
  
        // Al crear un objeto Cesta se verifica si
	// existe una variable SESSION con el ID de la cesta
	// para obtener sus datos desde la tabla
	if (isset($_SESSION['Cesta'])) { // ya existe una cesta
		 $sql = "SELECT * FROM Cesta
                 WHERE CestaID = " . $_SESSION['Cesta'] ;

		$rst = accederMySQL($sql);
       
		// Se asigna la matriz de propiedades del
		// objeto Cesta 
		$this->_aLista = $rst->fetch_assoc();
		// Se leen los tems de la cesta
		$this->leerItemsCesta();
	} else { // no existe una cesta
		// se inserta una cesta nueva en la tabla
		// a nombre del Cliente vigente en la sesin
		// el identificador de la cesta lo asignar MySQL
		// y despus lo recogeremos como resultado de
		// la operacin SQL
		$this->aadirCesta();
	} 

} // fin constructor
    
function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
		// devuelve el elemento de la matriz que corresponde
		// al nombre de campo solicitado
		return $this->_aLista[$nv];
	}
	else {
		// si el elemento no existe en la matriz
		// devuelve False
		// Este sera un error de codificacin, ya
		// que se estara solicitando una columna
		// con un nombre errneo (no existe en la tabla)
		return False;
	}

}  // fin funcin _get
	 
function __set($nv,$val){
	// asigna un valor a un elemento de la matriz
	// funcin genrica para asignar valores a las columnas
	// (o propiedades) del objeto		 
	$this->_aLista[$nv] = $val;
	
	// se marca que el objeto tiene un campo actualizado
	// respecto al contenido en la tabla
	// esto obligar a un Update
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set
	
function aadirCesta(){ // Aadir una cesta
     
	// Rutina de insercin de una nueva cesta
	$dNow = date("Y-m-d H:i:s");
	$sql = "INSERT INTO Cesta (ClienteID, FechaCreacion )
                VALUES
                (" . $_SESSION ['Cliente'] . ", '" . $dNow . "');";

	$this->_aLista['CestaID'] = accederMySQL($sql,"ID");
	$_SESSION['Cesta'] = $this->_aLista['CestaID'];
	$this->_aLista['FechaCreacion'] = $dNow;
        
} // fin funcin aadirCesta
    
function modificarCesta() {// Actualizar cesta

	// Rutina de actualizacin de la cesta
	// no hay modificaciones pendientes
	if (!$this->_bDirty) return;
         
	$sql= "UPDATE Cesta SET ";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "CestaID") {    
                  $sql =  $sql . " " . $key . " = '". $value . "' ,";
		}
	}
	$sql = substr($sql,0,strlen($sql)-1)." WHERE CestaID = ".$this->CestaID .";";
	$rst=AccederMySQL($sql);
	
	// saca la marca al indicador
	// de actualizacin pendiente
	$this->_bDirty = False;
        
} // fin funcin modificarCesta
    
function eliminarCesta() {
 
	//elimina la cesta
    if (isset($_SESSION['Cesta'])) {
    	// elimina los items de cesta
    	// se podra haber definido la relacin 
		// Cesta e ItemCesta de manera que se
		// produjese el borrado automtico en cascada
		// pero se prefiere este mtodo
		$sql= "DELETE FROM ItemCesta
            WHERE   CestaID = \"".$_SESSION['Cesta']."\";";

    	$rst=accederMySQL($sql);
         
	    // ahora elimina la cesta
		$sql= "DELETE FROM Cesta
            WHERE  CestaID = \"".$_SESSION['Cesta']."\";";

		$rst=accederMySQL($sql);
 
	}
} // fin funcin eliminarCesta

function leerItemsCesta() { // Lee contenido con descripcin

	// Se crea un objeto ItemCesta
	// y se lee la tabla ItemCesta utilizando
	// el objeto ItemCesta
	$oItemsCesta = New ItemsCesta;
	$this->_aItems = array();
	$this->_aItems = $oItemsCesta->leerItemsCesta();
	// devuelve la matriz de resultados
	return $this->_aItems;
      
}  // fin funcin leerItemsCesta

function totalizarCesta() { // suma campos
	
	// calcula el sumatorio vigente
	$this->_aLista['AcumPrecio'] = 0;
	$this->_aLista['AcumIVA'] = 0;
	$this->_aLista['AcumPeso'] = 0;
	$this->_aLista['AcumPrecioVP'] = 0;
	$this->_aLista['TotalCargo'] = 0;
	$this->_aLista['GastosEnvio'] = 0;
	
	foreach($this->_aItems as $item){
      		$this->_aLista['AcumPrecio'] += $item['PrecioT'];
      		$this->_aLista['AcumIVA'] += $item['IVAT'];
      		$this->_aLista['AcumPeso'] += $item['PesoT'];
      		$this->_aLista['AcumPrecioVP'] += $item['PrecioVP'];
    }
    
    // Calcula los gastos de envo
    $this->_aLista['GastosEnvio']=tarifaEnvio($this->AcumPeso,$this->TipoEnvio);

    // Calcula el cargo total
    $this->_aLista['TotalCargo']=$this->AcumPrecioVP+$this->GastosEnvio;
      
}  // fin funcin totalizarCesta
    
 
function cantItemsCesta() {
	
	// informa la cantidad de ItemsCesta
	$i = count($this->_aItems);
	return $i;
	
} // fin funcin cantItemsCesta

function leerCesta(){
         

	// Rutina de lectura de una cesta
	$sql = "SELECT * FROM Cesta
                 WHERE CestaID = '" . $this->CestaID."'";

	$rst=accederMySQL($sql);
	$this->_aLista = array();
	$this->_aLista = $rst->fetch_assoc();
	return $this->_aLista;
        
   	 
} // fin leerCesta

} // fin clase Cesta

?>

