<?php
class Departamento { // clase Departamento
	// archivo clDepartamento.php
	// explicacin en captulo 15

	/**
    * Propiedad
    */
	private $_aLista;
	private $_bDirty;
	/*
    * Mtodos
    * Departamento() // Constructor
    * aadirDepartamento()
    * modificarDepartamento()
    * eliminarDepartamento()
    * leerDepartamento()
    */


function __construct($iDepartamentoID=0){

	// si no se recibe un parmetro se asume el ID = 0

	// se crea la matriz que contendr todas las
	// columnas de un objeto Departamento

	$this->_aLista = array();
	$this->_bDirty = False;

	// cuando el ID es diferente a 0 es porque se quiere
	// crear un objeto departamento con datos ya existentes
	// en la tabla
	if ($iDepartamentoID <>0)  { // ya existe el Departamento
		$this->DepartamentoID = $iDepartamentoID;
		// se carga la matriz _aLista
		$this->leerDepartamento();
	}

} // fin constructor

function __get($nv){

	// funcin genrica para la obtencin de campos del objeto

	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
		// devuelve el elemento de la matriz que corresponde
		// al nombre de campo solicitado
		return $this->_aLista[$nv];
	}
	else{
		// si el elemento no existe en la matriz
		// devuelve False
		// Este sera un error de codificacin, ya
		// que se estara solicitando una columna
		// con un nombre errneo (no existe en la tabla)
		return False;
		}
}  // fin funcin _get

function __set($nv,$val){

	// funcin genrica para asignar valores a las columnas
	// (o propiedades) del objeto
	$this->_aLista[$nv] = $val;
	// se marca que el objeto tiene un campo actualizado
	// respecto al contenido en la tabla
	// esto obligar a un Update
	$this->_bDirty = True;
	return True;

} // fin funcin _set


function aadirDepartamento() {

	// Rutina de insercin de un nuevo departamento
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");

	// sentencia SQL de insercin
	$sql="INSERT INTO Departamentos
            (DepartamentoRaizID,
             Nombre,
             Imagen,
             UltimaMod,
             FechaCreacion)
            VALUES
            (\"".$this->DepartamentoRaizID."\",
             \"".$this->Nombre."\",
             \"".$this->Imagen."\",
             \"".$this->UltimaMod."\",
             \"".$this->FechaCreacion."\");";

        // se obtiene el ID como respuesta de la insercin
	$this->DepartamentoID = accederMySQL($sql,"ID");

	// $this->DepartamentoID se almacena en el elemento
	// _aLista['DepartamentoID'] mediante el mtodo _set

} // fin funcin aadirDepartamento()

function modificarDepartamento() {


	// si no hay cambios pendientes de actualizar
	// retorna sin hacer nada
	if (!$this->_bDirty)    return  ;

	$this->UltimaMod = date("Y-m-d H:i:s");
	// se controla que un departamento no dependa de s mismo
	if ($this->DepartamentoID == $this->DepartamentoRaizID){
		tratarError(LIT16005);
		return;
	}

	// sentencia SQL de modificacin de campos
	$sql="UPDATE Departamentos SET
            DepartamentoRaizID =\"". $this->DepartamentoRaizID."\",
            Nombre = \"".$this->Nombre."\",
            Imagen = \"".$this->Imagen."\",
            UltimaMod = \"".$this->UltimaMod."\"
            WHERE
            DepartamentoID = \"".$this->DepartamentoID."\";";

	// se averigua cuntas filas quedaron afectadas
	$aRows = accederMySQL($sql,"ROWS");
	if ($aRows == 0) {
		tratarError(LIT16003,$sql);
	}

	// se vuelve a anular el indicador de
	// actualizacin pendiente
	$this->_bDirty = False;

} // fin funcin modificarDepartamento()

function eliminarDepartamento() {
      // se verifica que ese departamento no tenga otros departamentos
      // dependientes  es una autoreferencia a la propia tabla

	$sql="SELECT Count(*) FROM Departamentos
            WHERE
            DepartamentoRaizID = \"".$this->DepartamentoID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);


	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		// No se elimina el departamento: otros departamentos dependen de l.
		tratarError(LIT16001);
		$rst->free();
		return;
	}

	// Vinculaciones
	// por si no se activa el control de relaciones
	// esto es redundante, ya que MySQL
	// controlar la relacin

	$sql="SELECT Count(*) FROM Libros
            WHERE DepartamentoID = \"".$this->DepartamentoID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);

	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		// No se elimina el departamento: hay libros que dependen de l.
		tratarError(LIT16002);
		$rst->free();
		return;
	}

        // Ahora s, podemos eliminar ese departamento
	$sql="DELETE FROM Departamentos
			WHERE DepartamentoID = \"".$this->DepartamentoID."\";";
	$aRows = accederMySQL($sql,"ROWS");
	if ($aRows == 0) {
		tratarError(LIT16004,$sql);
	}

} // fin funcin eliminarDepartamento()

private function leerDepartamento(){
        // Observar que esta funcin es private
	// slo se usa internamente

	// Rutina de lectura de un  Departamento
	$sql = "SELECT * FROM Departamento
			WHERE DepartamentoID = " . $this->DepartamentoID ;

	$rst = accederMySQL($sql);

        // se asigna la matriz con el resultado de la select
	$this->_aLista = $rst->fetch_assoc();

} // fin funcin leerDepartamento()

}

?>
