<?php
class Libro { // clase Libro
    // archivo  \bib\clases\clLibro.php
    //explicacin captulo 17

	private $_aLista = array();
	private $_bDirty=False;


    /*
    * Mtodos
    * Libro($sLibroID) // Constructor
    * leerLibro($sLibroID)
    * aadirLibro(...)
    * modificarLibro
    * eliminarLibro
    * comprobarExistencias($iUnidades)
    * reducirExistencias($iUnidades)
    */

function __construct($sLibroID=""){

	// tiene identificador?

	if ( $sLibroID <> "")  $this->_aLista['LibroID']=$sLibroID;

}  // fin constructor

function __get($nv){

	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
	    // devuelve el elemento de la matriz que corresponde
	    // al nombre de campo solicitado
	    return $this->_aLista[$nv];
	}
	else {
		// si el elemento no existe en la matriz
		// devuelve False
		// Este sera un error de codificacin, ya
		// que se estara solicitando una columna
		// con un nombre errneo (no existe en la tabla)
		return False;
	}

}  // fin funcin _get

function __set($nv,$val){

	// asigna un valor a un elemento de la matriz
	// funcin genrica para asignar valores a las columnas
	// (o propiedades) del objeto
	$this->_aLista[$nv] = $val;

	// se marca que el objeto tiene un campo actualizado
	// respecto al contenido en la tabla
	// esto obligar a un Update
	$this->_bDirty = True;
	return True;

} // fin funcin _set

function leerLibro(){

	// Rutina de lectura de un  Libro
	$sql = "SELECT * FROM Libros
                 WHERE LibroID = '" . $this->LibroID."'";

	$rst = accederMySQL($sql);
	$this->_aLista = $rst->fetch_assoc();
	return $this->_aLista;


} // fin leerLibro

function aadirLibro(){

	// si no hay cambios de propiedades
	// no hay nada para insertar
	if (!$this->_bDirty) return;

	$sql ="INSERT INTO Libros(LibroID, DepartamentoID, ";
  	$sql.=   "Nombre, DetalleMenor, DetalleMayor, Autor, ";
  	$sql.=   "Editorial, Paginas, Cubierta, Tema, Imagen, ";
  	$sql.=   "Peso, Precio, IVA, Existencias, ProveedorID) ";
  	$sql.=   "VALUES (\"";
  	$sql.=    $this->LibroID."\",\"";
  	$sql.=    $this->DepartamentoID."\",\"";
  	$sql.=    $this->Nombre."\",\"";
  	$sql.=    $this->DetalleMenor."\",\"";
  	$sql.=    $this->DetalleMayor."\",\"";
  	$sql.=    $this->Autor."\",\"";
  	$sql.=    $this->Editorial."\",\"";
  	$sql.=    $this->Paginas."\",\"";
  	$sql.=    $this->Cubierta."\",\"";
  	$sql.=    $this->Tema."\",\"";
  	$sql.=    $this->Imagen."\",\"";
  	$sql.=    $this->Peso."\",\"";
  	$sql.=    $this->Precio."\",\"";
  	$sql.=    $this->IVA."\",\"";
  	$sql.=    $this->Existencias."\",\"";
  	$sql.=    $this->ProveedorID."\");";
 	$rst = accederMySQL($sql);
    $this->_bDirty = False;

} // fin aadirLibro


function modificarLibro() {

	// Rutina de modificacin de libros
	// si no hay cambios de propiedades
	// no hay nada para actualizar
	if (!$this->_bDirty) return;

	$this->UltimaMod = date("Y-m-d H:i:s");
	$sql= "UPDATE Libros SET ";
	foreach ($this->_aLista as $key => $value){
		if ($key <> "LibroID"){
			$sql =  $sql . " " . $key . " = '". $value . "' ,";
		}
	}
	$sql = substr($sql,0,strlen($sql)-1)." WHERE LibroID = \"".$this->LibroID ."\";";

	$rst = accederMySQL($sql);
	$this->_bDirty = False;

}

function eliminarLibro() {

      $sql="DELETE FROM Libros WHERE LibroID = \"".$this->LibroID."\";";
      $rst = accederMySQL($sql);

} // fin EliminarLibro

function comprobarExistencias($iUnidades){

	////////////////////////////////////////////////////////
	// Comprobar existencias en el catlogo
	////////////////////////////////////////////////////////
	$sql = "SELECT * FROM Libros
             WHERE
                LibroID = \"".$this->LibroID."\" AND
                Existencias >= ".$iUnidades.";";

	$rows = accederMySQL($sql,"ROWS");
	if ($rows > 0) return TRUE;
	return FALSE;


} // fin comprobarExistencias

function reducirExistencias($iUnidades){

	////////////////////////////////////////////////////////
	// Reducir existencias en el catlogo
	////////////////////////////////////////////////////////
	$sql = "UPDATE Libros
             SET  Existencias = (Existencias - ".$iUnidades.")
             WHERE  LibroID = \"".$this->LibroID."\" AND
                    Existencias >= ".$iUnidades.";";

	$rows = AccederMySQL($sql,"ROWS");
	// lee nuevamentte el libro
	$this->leerLibro($this->LibroID);
	return $rows;


} // fin reducirExistencias



} // fin clase Libro

?>

