<?php
class Newsletter { // clase Newsletter
    // archivo \bib\clases\clNewsletter.php
    // explicacin en captulo 29

	private $_aLista=array();
	private $_bDirty=False;

   /*
    * Mtodos
    * __construct() // Constructor
    * aadirNewsletter()
    * modificarNewsletter()
    * leerNewsletter()
    * enviarNewsletter()
    * 
    */

function __construct($iNewsID=0){

    	// si no se recibe un parmetro se asume el ID = 0

	// se crea la matriz que contendr todas las
	// columnas de un objeto Newsletter

	// obtiene los datos de un Newsletter

	$this->NewsID = $iNewsID;
	// cuando el ID es diferente a 0 es porque se quiere
	// crear un objeto Newsletter con datos ya existentes
	// en la tabla
	if ($iNewsID <>0)  { // ya existe el Newsletter
            $this->leerNewsletter($iNewsID);
	}


} // fin constructor

function __get($nv){

	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
	    // devuelve el elemento de la matriz que corresponde
	    // al nombre de campo solicitado
	    return $this->_aLista[$nv];
	}
	else {
		// si el elemento no existe en la matriz
		// devuelve False
		// Este sera un error de codificacin, ya
		// que se estara solicitando una columna
		// con un nombre errneo (no existe en la tabla)
		return False;
	}

}  // fin funcin _get

function __set($nv,$val){

	// asigna un valor a un elemento de la matriz
	// funcin genrica para asignar valores a las columnas
	// (o propiedades) del objeto
	$this->_aLista[$nv] = $val;

	// se marca que el objeto tiene un campo actualizado
	// respecto al contenido en la tabla
	// esto obligar a un Update
	$this->_bDirty = True;
	return True;

} // fin funcin _set

function aadirNewsletter() { // Aadir un nuevo Newsletter

	// Rutina de insercin de un nuevo Newsletter
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");
	$sqln="";
	$sqlv="";
	foreach ($this->_aLista as $key => $value){
		if ($key <> "NewsID"){
                  $sqln =  $sqln .  $key. " ,";
                  $sqlv = $sqlv . "\"".$value."\",";
        }
	}
	$sql = "INSERT INTO Newsletter ( ".substr($sqln,0,strlen($sqln)-1).
                ") VALUES (".substr($sqlv,0,strlen($sqlv)-1).");";

 	// obtiene el valor de autoincremento
	$this->NewsID = accederMySQL($sql,"ID");
	$this->_Dirty = False;


} // fin aadirNewsletter()

function modificarNewsletter() { // Modifica los datos de un Newsletter

	// Rutina de modificacin de Newsletter
	// no hay modificaciones pendientes
	if (!$this->_bDirty) return;


	$this->UltimaMod = date("Y-m-d H:i:s");
	$sql= "UPDATE Newsletter SET ";
	foreach ($this->_aLista as $key => $value){
		if ($key <> "NewsID"){
			$sql =  $sql . " " . $key . " = \"". $value . "\" ,";
		}
	}
	$sql = substr($sql,0,strlen($sql)-1)." WHERE NewsID = ".$this->NewsID .";";

	$rst = accederMySQL($sql);
	// Quita la marca de actualizacin pendiente
	$this->_bDirty = False;


} // fin ModificarNewsletter

function eliminarNewsletter() {

    // se verifica que ese Newsletter 
    // no tenga referencia en clientes
    $sql="SELECT Count(*) FROM Clientes
            WHERE
            NewsID = \"".$this->NewsID."\";";

	// crea el conjunto de resultados
	$rst=accederMySQL($sql);


	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		// No se elimina el Newsletter: es Newsletter vigente.
		tratarError(LIT16008);
		return;
	}

	$sql="DELETE FROM Newsletter
			WHERE NewsID = \"".$this->NewsID."\";";

 	$rst = accederMySQL($sql);
 	$rst->free();

}

function leerNewsletter($iNewsID){

	// Rutina de lectura de un  Newsletter
	$sql = "SELECT * FROM Newsletter
                 WHERE NewsID = " . $iNewsID ;

	$rst = accederMySQL($sql);

	$this->_aLista = $rst->fetch_assoc();
	$rst->free();


} // fin leerNewsletter

function enviarNewsletter(){

	// Rutina de lectura de los clientes
	$sql = "SELECT * FROM Clientes
                 WHERE Suscriptor = 'S'";

	$rst = accederMySQL($sql);
	
	$suscriptores = array(); 
	// Bucle por el conjunto de resultados
	while ($aFila = $rst->fetch_assoc()) {
		$suscriptores[$i] = $aFila;
		$i++;
	}
        
	echo "Newsletter Nro. " . $this->NewsID . "<BR>";
	
	/////////////////////////////////////////////////////////////
	// Email a cada suscriptor
	/////////////////////////////////////////////////////////////
        $cont = 0; 
	foreach($suscriptores as $asusc ){
	    $to = $asusc['EMail'] ."\r\n";
	    // direccin de email con signos <...>  
	    $subject = EMPRESA ." ".LIT22006;
	
	    $body = "<html><head><title>".LIT22006." ".$this->_aLista['Fecha']." </title></head>";
	    $body .= "<body>Estimado ".$asusc['Nombre'].":<br>".$this->_aLista['Noticia']."<br><br>";
	    $body .= LIT07004.DE_EMAIL."</body></html>\r\n";
	
	    $header = "MIME-Version: 1.0\r\n";
	    $header .= "Content-type: text/html; charset=iso-8859-1\r\n";
	    $header .= "To: " . $to ."\r\n";
	    $header .= "From:" . DE_EMAIL ."\r\n";
	    // From con signos <....>
	    echo "Email enviado a :". $to . "<BR>";
	    $cont++;
	    mail($to, $subject, $body, $header);
	    
	}
	echo "Se enviaron en total " . $cont . " emails<BR>";
	
	$this->_aLista['Estado'] = 'Enviado';
	$_bDirty = true;
	$this->modificarNewsletter(); 
	$rst->free();


} // fin enviarNewsletter

} // fin clase

?>

