<?php
class Pedido { // clase Pedido
	// archivo \bib\clases\clPedido.php
	// explicacin captulo 23
	
    /**
     * Propiedades
     */
    private $_aLista=array();
    private $_bDirty=False;
    /*
    * Mtodos
    * __construct($iPedido) // Constructor
    * leerPedido($iPedido)
    * aadirPedido()
    * modificarPedido()
    * eliminarPedido()
    */
      
function __construct($iPedido){
         
	// lectura de un pedido existente
	if ($iPedido<>0) { // ya existe el pedido
		$this->PedidoID = $iPedido;
		$this->leerPedido();
	}	  
	else {
		// elimina un pedido previo de la cesta vigente
		$this->eliminarPedido();
	}	
      

} // fin constructor 
    
function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
		// devuelve el elemento de la matriz que corresponde
		// al nombre de campo solicitado
		return $this->_aLista[$nv];
	}	
	else {
		// si el elemento no existe en la matriz
		// devuelve False
		// Este sera un error de codificacin, ya
		// que se estara solicitando una columna
		// con un nombre errneo (no existe en la tabla)
		return False;
	}

}  // fin funcin _get
	 
function __set($nv,$val){
	// asigna un valor a un elemento de la matriz
	// funcin genrica para asignar valores a las columnas
	// (o propiedades) del objeto			 
	$this->_aLista[$nv] = $val;
	
	// se marca que el objeto tiene un campo actualizado
	// respecto al contenido en la tabla
	// esto obligar a un Update
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set

private function leerPedido(){
         
	// Rutina de lectura de un  pedido
	$sql = "SELECT * FROM Pedidos
                 WHERE PedidoID = " . $this->PedidoID ;

	$rst=accederMySQL($sql);
	
	// utiliza los resultados de la consulta
	// para cargar la matriz _aLista
	$this->_aLista = $rst->fetch_assoc();

   	 
} // fin leerPedido

function aadirPedido() {  
      

	$dNow = date("Y-m-d H:i:s");
	$this->UltimaMod= $dNow;
	$this->FechaCreacion= $dNow;
	$sql =   "INSERT INTO Pedidos
          (ClienteID,
           FechaPedido,
           Nombre,
           Apellidos,
           EMail,
           Direccion,
           Ciudad,
           Provincia,
           CodigoPostal,
           Telefono,
           FAX,
           TipoTarjeta,
           NumeroTarjeta,
           NombreEntarjeta,
           FechaCaducidad,
           TipoEnvio,
           MedioPago,
           PesoEnvio,
           GastosEnvio,
           PrecioSinIVA,
           IVA,
           TotalCargo,
           Estado,
           FechaEstado,
           UltimaMod,
           FechaCreacion)
       VALUES
          (\"".$this->ClienteID."\",
          \"".$dNow."\",
          \"".$this->Nombre."\",
          \"".$this->Apellidos."\",
          \"".$this->EMail."\",
          \"".$this->Direccion."\",
          \"".$this->Ciudad."\",
          \"".$this->Provincia."\",
          \"".$this->CodigoPostal."\",
          \"".$this->Telefono."\",
          \"".$this->FAX."\",
          \"".$this->TipoTarjeta."\",
          \"".$this->NumeroTarjeta."\",
          \"".$this->NombreEntarjeta."\",
          \"".$this->FechaCaducidad."\",
          \"".$this->TipoEnvio."\",
          \"".$this->MedioPago."\",
          \"".$this->PesoEnvio."\",
          \"".$this->GastosEnvio."\",
          \"".$this->PrecioSinIVA."\",
          \"".$this->IVA."\",
          \"".$this->TotalCargo."\",
          \"".$this->Estado."\",
          \"".$this->FechaEstado."\",
          \"".$this->UltimaMod."\",
          \"".$this->FechaCreacion."\");";
	
	// inserta la fila en la tabla Pedidos y 
	// recupera el identificador asignado
	// al pedido por MySQL
	$claveID = accederMySQL($sql,"ID");
	
	// almacena el ID
	$this->_aLista['PedidoID'] = $claveID;        
	$this->leerPedido();
         
	// actualiza la variable SESSION 
	$_SESSION['Pedido'] = $this->_aLista['PedidoID'];
     
       
} // fin funcin aadirPedido
    
function modificarPedido() { // Modifica los datos de un pedido

	// Rutina de actualizacin del pedido
	// si no hay modificaciones pendientes
	// retorna
	if (!$this->_bDirty) return;
	$this->UltimaMod = date("Y-m-d H:i:s");
        
	$sql= "UPDATE Pedidos SET ";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "PedidoID"){    
			$sql =  $sql . " " . $key . " = \"". $value . "\" ,";
		}
	}
	$sql = substr($sql,0,strlen($sql)-1)." WHERE PedidoID = ".$this->PedidoID .";";
 
	$rst = accederMySQL($sql);
	
	// saca la marca al indicador
	// de actualizacin pendiente
	$this->_bDirty = False;
         
         
} // fin modificarPedido      

function eliminarPedido() {
	
	IF (isset($_SESSION['Cesta'])){
 
		// ahora elimina un pedido en proceso del mismo cliente
		$sql= "DELETE FROM Pedidos
			WHERE   ClienteID = \"".$_SESSION['Cliente']."\" AND
			        Estado = \"".LIT07019."\" ;";
		
echo "<br>";
		echo $sql;
echo "<br>";
		$rst=accederMySQL($sql);
	}
 
} // fin funcin eliminarPedido

} // fin clase Pedido

?>

