<?php

class TablaHTML  { // clase TablaHTML
  // archivo TablaHTML.php
  // explicacin captulo 15
  
  private $aTCol; 			 // lista de ttulo de columnas
  private $aTFil; 			 // lista de ttulo de filas
  private $aTTab; 			 // lista de filas

  private $sEstiloCSS="";  	 // estilo css
  private $bTituloFila=FALSE; 	 // ttulo de filas
  private $bTituloColumna=FALSE; // Ttulos de columnas
  private $bEstiloCSS=FALSE;  // estilo

  private $indice_lin=1;            // ndice para carga de lneas
/*
    * Mtodos
    * __construct($varestilo="") // Constructor
    * asignar_titulos_columnas()
    * asignar_titulos_filas($titfila)
    * aadir_fila($line) 
    * retornoHTML()  
    */ 

// constructor de la clase TablaHTML
public function __construct($sEstilo="")   {
	
	// limpia las matrices internas
    $this->aTTab = array();
    $this->aTCol = array();
    $this->aTFil = array();
    
    // si hay un estilo, se utiliza
    if ($sEstilo!="")      {
      $this->sEstiloCSS=$sEstilo;
      $this->bEstiloCSS=TRUE;
    }
} // fin funcin  constructor


// mtodo para asignar ttulos a las columnas
// de la tabla
public function asignar_titulos_columnas()   {
    $numargs = func_num_args();

    for ($i=0;$i<$numargs;$i++)  {
    // carga la matriz de ttulo de columna
    // con cada uno de los parmetros de la funcin	
      $this->aTCol[$i]=func_get_arg($i);
    }
    // deja constancia de que existen
    // ttulos de columna
    $this->bTituloColumna=TRUE;
} // fin funcin asignar_titulos_columnas()


// mtodo para asignar ttulos a las filas
// de la tabla
public function asignar_titulos_filas($titfila)   {
    // contar la cantidad de elementos
    $numargs = sizeof($titfila);

    $this->aTFil[0]="";
    for ($i=0;$i<$numargs;$i++) {
      // asigna los ttulos de las filas 	
      $this->aTFil[$i]=$titfila[$i];
    }
    // deja constancia de que existen
    // ttulos de fila
    $this->bTituloFila=TRUE;
} // fin funcin asignar_titulos_filas()


// mtodo para aadir filas
public function aadir_fila($line)   {
      $this->aTTab[$this->indice_lin]=$line;
      $this->indice_lin++;
} // fin funcin aadir_fila()


// Genera el cdigo HTML
public function retornoHTML()   {
    // mtodo para generar el cdigo HTML a partir
    // de los datos almacenados en las matrices
    $sCodeHTML="<!--| inicio tabla ttulo de columnas |-->\n";
    $iSpan=1;
    
    // si se ha informado un estilo, se asigna la clase de la tabla
    if ($this->bEstiloCSS==TRUE)
      $sCodeHTML.='<table class="'.$this->sEstiloCSS.'" >';
    else
      $sCodeHTML.='<table>';

    // Si se han informado cabeceras de ttulo
    // se crea la fila de ttulo de coloumna
    if ($this->bTituloColumna==TRUE)  {
        $sCodeHTML.='<tr><th></th>';
        foreach($this->aTCol as $stabtcol)  {
           if ($stabtcol == "")   {
               $iSpan++;
           }
           else  {
              $sCodeHTML.='<th colspan="'.$iSpan.'">'.$stabtcol.'</th>';
              $iSpan= 1;
           }
        }
        $sCodeHTML.='</tr>';
    }


    // Informa lneas de la tabla
    $i=0;
    foreach($this->aTTab as $atabfilas)  {
      // si se han informado ttulos de fila
      if ($this->bTituloFila==TRUE)  {
        $sCodeHTML.='<tr><th>'.$this->aTFil[$i].'</th>';
        $i++;
      }
      // informa la lnea de la tabla
      foreach ($atabfilas as $stabcel)  {
          $sCodeHTML.='<td>'.$stabcel.'</td>';
      }

      // cierre del registro de la tabla
      $sCodeHTML.='</tr>';
     }

     // final de la tabla
     $sCodeHTML.='</table>"<!--| fin tabla ttulo de columnas |-->"';

     // devuelve la cadena HTML
     return $sCodeHTML;
} // fin funcin retornoHTML()
   
} // fin clase
?>
