<?php
class Tema {
	// archivo clTema.php
	// explicacin captulo 26

	/**
	* Propiedad 
	*/
	private $_aLista=array();
	private $_bDirty=False;
	/*
    * Mtodos
    * __construct() // Constructor
    * aadirTema
    * modificarTema
    * eliminarTema
    * leerTema
    */
 
function __construct($iTemaID=0){
     
	// lectura del tema
	if ($iTemaID <>0)  { // ya existe el Tema
		$this->TemaID = $iTemaID;
		$this->leerTema();
	}  

} // fin constructor

function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
		// devuelve el elemento de la matriz que corresponde
		// al nombre de campo solicitado
		return $this->_aLista[$nv];
	}		
	else{
		// si el elemento no existe en la matriz
		// devuelve False
		// Este sera un error de codificacin, ya
		// que se estara solicitando una columna
		// con un nombre errneo (no existe en la tabla)
		return False;
	}
	
}  // fin funcin _get
	 
function __set($nv,$val){
	// asigna un valor a un elemento de la matriz
	// funcin genrica para asignar valores a las columnas
	// (o propiedades) del objeto		 
	$this->_aLista[$nv] = $val;
	
	// se marca que el objeto tiene un campo actualizado
	// respecto al contenido en la tabla
	// esto obligar a un Update
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set


function aadirTema() {
      
	// Rutina de insercin de un nuevo Tema
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");
	$sql="INSERT INTO Temas
            (TemaRaizID, 
             Nombre, 
             Imagen,
             UltimaMod,
             FechaCreacion) 
            VALUES 
            (\"".$this->TemaRaizID."\",
             \"".$this->Nombre."\",
             \"".$this->Imagen."\",
             \"".$this->UltimaMod."\",
             \"".$this->FechaCreacion."\");";
      
	$this->TemaID = accederMySQL($sql,"ID");
      
 
} // fin funcin aadirTema()

function modificarTema() {
	 
	$this->UltimaMod = date("Y-m-d H:i:s");
	$sql="UPDATE Temas SET 
            	TemaRaizID =\"". $this->TemaRaizID."\",
            	Nombre = \"".$this->Nombre."\", 
            	Imagen = \"".$this->Imagen."\", 
            	UltimaMod = \"".$this->UltimaMod."\" 
            WHERE 
            	TemaID = \"".$this->TemaID."\";";
     $rst = accederMySQL($sql);
     $rst->free();
     
} // fin funcin modificarTema()

function eliminarTema() {
	
	// se verifica que ese Tema no tenga otros Temas dependientes
	// es una autoreferencia a la propia tabla
          
	$sql="SELECT Count(*) FROM Temas 
            WHERE 
            	TemaRaizID = \"".$this->TemaID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);


	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		echo  LIT18001;
		$rst->free();
		return;
	}
      
	// Vinculaciones
	// por si no se activa el control de relaciones
      
	$sql="SELECT Count(*) FROM Articulos 
            WHERE 
            TemaID = \"".$this->TemaID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);

	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		echo  LIT18002;
		$rst->free();
		return;
	}
      
	$sql="DELETE FROM Temas 
			WHERE 
			TemaID = \"".$this->TemaID."\";";
	$rst = accederMySQL($sql);
	$rst->free();
	
} // fin funcin eliminarTema()

private function leerTema(){
         
	// Rutina de lectura de un  Tema
	$sql = "SELECT * FROM Temas
				WHERE 
					TemaID = " . $this->TemaID ;

	$rst = accederMySQL($sql);
	$this->_aLista = $rst->fetch_assoc();
	$rst->free();	
   	 
}
 
} // fin clase Tema 

?>
