<?php
// archivo: anularpedido.php
// explicacin captulo 25

// objetivo: anula un pedido en trmite

// esta pgina se carga por orden de PayPal
// al no poder realizarse el pago, se anula
// el pedido, aunque la cesta se 
// mantiene, por si el cliente quiere
// modificar algo 

require_once("plantilla.php");

// Si se quiere probar esta pgina de modo independiente
// ajustar estos valores y activar las siguientes
// instrucciones 
//$_SESSION['Pedido']= 11;
//$_SESSION['Cliente']= 2;

// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUGEN);

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios limitados
////////////////////////////////////////////////////
conectar(USERNORMAL,PSWUSERNORMAL);

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaC($aMENU01,LIT00006); 

////////////////////////////////////////////////////
// Si no hay pedido activo se vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Pedido']))
	redirect("index.php");

////////////////////////////////////////////////////
// Si no est en sesin debe autenticarse
////////////////////////////////////////////////////
if (!isset($_SESSION['Cliente']))
    redirect("autenticarse.php");

////////////////////////////////////////////////////
// Obtener datos del pedido
////////////////////////////////////////////////////
// Crea un objeto Pedido en base al pedido vigente
// segn la variable $_SESSION
$oPedido = New Pedido($_SESSION['Pedido']);

// Verifica el estado del pedido
// debe estar "En proceso"
if (($oPedido->Estado <> LIT07019)||
	($oPedido->ClienteID <> $_SESSION['Cliente'])) {
	// Situacin incorrecta del pedido
	echo LIT17003;	
}
else {
	
	///////////////////////////
	// Actualizacin del pedido
	//////////////////////////// 
	// se marca al pedido como Cancelado
	$oPedido->Estado=LIT17001;
	$oPedido->FechaEstado=date("Y-m-d H:i:s");

	$oPedido->modificarPedido();

	// este  pedido ya no se puede reutilizar
	// pero la cesta queda abierta
	// para que el cliente pueda modificar algo
	// por ejemplo, reducir la compra o cambiar
	// el medio de pago
	unset($_SESSION['Pedido']);

	// Lo lamentamos, pero su pedido no ha podido ser cobrado. Pedido cancelado 
	echo LIT17002;
}

// informacin de pie de pgina
cerrarPagina();

?>