<?php
// archivo: vercesta.php
// objetivo: visualizar contenido de la cesta
// explicacin en captulo 21

// Esta pgina permite visualizar los productos
// colocados en la cesta

require_once("plantilla.php");

// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUGEN);

 
////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios limitados
////////////////////////////////////////////////////
conectar(USERNORMAL,PSWUSERNORMAL);

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaC($aMENU01,LIT00005); 

// Si se quiere probar esta pgina de modo independiente
// ajustar estos valores y activar las siguientes
// instrucciones 
//$_SESSION['Cliente']= 3;
//$_SESSION['Cesta']= 1;

////////////////////////////////////////////////////
// Si no hay cesta activa vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Cesta']))
	redirect("index.php");
	
// Recupera de la cesta vigente
$oCesta = New Cesta;

// Rutina de modificacin de un item de la cesta
$oItemCesta = new ItemCesta;
switch ($_POST["Op"]){
case "Modificar":
      $oItemCesta->modificarItemCesta($_POST["vItemCestaID"],$_POST["vCantidadUnidades"]);
      break;
case "Eliminar":
      $oItemCesta->eliminarItemCesta($_POST["vItemCestaID"]);
      break;
default:
}  

// obtiene todo el contenido de la cesta
$aCesta = $oCesta->leerItemsCesta();

// Crea un objeto TablaHTML
$oTab2 = new  TablaHTML("comercio");

// Coloca los ttulos de las columnas
$oTab2->asignar_titulos_columnas(
       LIT02007, LIT02002, LIT02005, LIT02011,
       LIT06001, LIT06002, "", "", LIT06003);

// Formularios para la eliminacin y modificacin de item de cesta
$i=0;
while ($i < $oCesta->cantItemsCesta())  {

  // limpia la matriz
  unset($aB);
  // formulario para eliminaciones y modificaciones
  $aB[0]="<form name='form12".$i."' method=\"POST\" action=\"".SELF."\" enctype=\"multipart/form-data\">";
  $aB[0].="<input type='hidden' name='vItemCestaID' value='".$aCesta[$i]['ItemCestaID']."'>";
  $aB[0].="<input type='hidden' name='vCestaID' value='".$aCesta[$i]['CestaID']."'>";
  $aB[0].="<input type='hidden' name='vLibroID' value='".$aCesta[$i]['LibroID']."'>";
  $aB[0].= clean($aCesta[$i]['LibroID']);
  $aB[1]=clean($aCesta[$i]['Nombre']);
  $aB[2]=clean($aCesta[$i]['Autor']);
  $aB[3]=$aCesta[$i]['Precio']+$aCesta[$i]['IVA'];
  $aB[4]="<input type='text' size='3' name='vCantidadUnidades' value='".$aCesta[$i]['CantidadUnidades']."'>";
  $aB[5]=($aCesta[$i]['Precio']+$aCesta[$i]['IVA'])*$aCesta[$i]['CantidadUnidades'];
  $aB[6]="<input type='image' src ='".PATHGIF."eliminar.gif'   
  value='Eliminar' TITLE='".LIT00007."'   onClick='document.form12".$i.".Op.value=\"Eliminar\";' >";
  $aB[6].="<input type='image' src ='".PATHGIF."modificar.gif'  
  value='Modificar' TITLE='".LIT00008."' onClick='document.form12".$i.".Op.value=\"Modificar\";' >";
  $aB[6].="<input type='hidden' name='Op' value=' '></form>";
  
  // formulario para visualizar el producto
  $aB[7]="<form name='form13".$i."' method=\"POST\" action=\"index.php\" enctype=\"multipart/form-data\">";
  $aB[7].="<input type='hidden' name='vLibroID' value='".$aCesta[$i]['LibroID']."'>";
  $aB[7].="<input type='image' src ='".PATHGIF."buscar.jpg'   
  value='Ver' TITLE='".LIT00010."' width='20' height='20' onClick='document.form13".$i.".Op.value=\"Ver\";' >";
  $aB[7].="<input type='hidden' name='Op' value=' '>";
  $aB[7].="</form>";

  // el ttulo de la fila es simplemente el nmero de lnea
  $sTitFila[]=++$i;

  $oTab2->aadir_fila($aB);
}

// coloca los ttulos de cada fila
$oTab2->asignar_titulos_filas($sTitFila);

// imprime los formularios
echo $oTab2->retornoHTML();
echo "</form>";

// informacin de pie de pgina
cerrarPagina();

?>